$INTERFACE U1FDU1                                             97/12/01
$REM LU
$N='N'
$HERF='D'
$ADD(REAL,'\UXVDOT')
$ADD(INTEGER,'\IMD')
$CONS=CONSTR
$IF(CONSTR='U')
  $HELP
    TYPE OF METHOD:
      L - LINE SEARCH METHOD
      G - GENERAL TRUST REGION METHOD
  $CHECK(TYPE,'L','L\G',2,NO)
  $IF(TYPE='L')
    $HELP
      MATRIX DECOMPOSITION
        M - NO DECOMPOSITION
        G - GILL-MURRAY DECOMPOSITION WITHOUT PERMUTATIONS
        S - SCHNABEL-ESKOV DECOMPOSITION WITH PERMUTATIONS
        B - BUNCH-PARLETT  DECOMPOSITION WITH PERMUTATIONS
        I - INVERSION
    $CHECK(DECOMP,'I','M\G\S\B\I\P',2,NO)
    $IF(DECOMP='M')
      $HELP
         METHOD
           1 - EXACT SOLUTION BY THE GILL-MURRAY DECOMPOSITION
           3 - INEXACT SOLUTION BY CONJUGATE GRADIENT METHOD
      $CHECK(NUMBER,1,'1\3',2,NO)
    $ELSE
      $NUMBER=1
    $ENDIF
  $ELSEIF(TYPE='G')
    $HELP
      MATRIX DECOMPOSITION
        M - NO DECOMPOSITION
        G - GILL-MURRAY DECOMPOSITION WITHOUT PERMUTATIONS
        S - SCHNABEL-ESKOV DECOMPOSITION WITH PERMUTATIONS
        B - BUNCH-PARLETT  DECOMPOSITION WITH PERMUTATIONS
    $CHECK(DECOMP,'G','M\G\S\B',2,NO)
    $IF(DECOMP='M')
      $DEFAULT=7
      $HELP
         METHOD
           1 - SINGLE DOG-LEG STRATEGIES
           2 - MULTIPLE DOG-LEG STRATEGY
           3 - INEXACT SOLUTION BY THE CONJUGATE GRADIENT METHOD
           4 - INEXACT SOLUTION BY THE CONJUGATE GRADIENT METHOD
               WITH THE LANCZOS STEPS
           5 - INEXACT SOLUTION BY THE CONJUGATE GRADIENT METHOD
               WITH THE LANCZOS STEPS
           6 - INEXACT SOLUTION BY THE CONJUGATE GRADIENT METHOD
               WITH THE LANCZOS STEPS
           7 - OPTIMUM LOCALLY CONSTRAINED STEP
      $CHECK(NUMBER,DEFAULT,'1\2\3\4\5\6\7',2,NO)
    $ELSE
      $HELP
         METHOD
           1 - SINGLE DOG-LEG STRATEGIES
           2 - MULTIPLE DOG-LEG STRATEGY
      $CHECK(NUMBER,1,'1\2',2,NO)
    $ENDIF
  $ENDIF
$ELSE
  $HELP
    TYPE OF METHOD:
      L - LINE SEARCH
      G - GENERAL TRUST REGION
  $CHECK(TYPE,'L','L\G',2,NO)
  $IF(TYPE='L')
    $HELP
      MATRIX DECOMPOSITION
        M - NO DECOMPOSITION
        G - GILL-MURRAY DECOMPOSITION WITHOUT PERMUTATIONS
        I - INVERSION
        P - PRODUCT FORM OF INVERSION
    $CHECK(DECOMP,'G','M\G\I\P',2,NO)
    $IF(DECOMP='M')
      $HELP
         METHOD
           1 - EXACT SOLUTION BY THE GILL-MURRAY DECOMPOSITION
           3 - INEXACT SOLUTION BY CONJUGATE GRADIENT METHOD
      $CHECK(NUMBER,1,'1\3',2,NO)
    $ELSE
      $NUMBER=1
    $ENDIF
  $ELSEIF(TYPE='G')
    $HELP
      MATRIX DECOMPOSITION
        M - NO DECOMPOSITION
        G - GILL-MURRAY DECOMPOSITION WITHOUT PERMUTATIONS
    $CHECK(DECOMP,'G','M\G',2,NO)
    $IF(DECOMP='M')
      $DEFAULT=7
      $HELP
         METHOD
           1 - SINGLE DOG-LEG STRATEGIES
           2 - MULTIPLE DOG-LEG STRATEGY
           3 - INEXACT SOLUTION BY THE CONJUGATE GRADIENT METHOD
           4 - INEXACT SOLUTION BY THE CONJUGATE GRADIENT METHOD
               WITH THE LANCZOS STEPS
           5 - INEXACT SOLUTION BY THE CONJUGATE GRADIENT METHOD
               WITH THE LANCZOS STEPS
           6 - INEXACT SOLUTION BY THE CONJUGATE GRADIENT METHOD
               WITH THE LANCZOS STEPS
           7 - OPTIMUM LOCALLY CONSTRAINED STEP
      $CHECK(NUMBER,DEFAULT,'1\2\3\4\5\6\7',2,NO)
    $ELSE
      $HELP
         METHOD
           1 - SINGLE DOG-LEG STRATEGIES
           2 - MULTIPLE DOG-LEG STRATEGY
      $CHECK(NUMBER,1,'1\2',2,NO)
    $ENDIF
  $ENDIF
$ENDIF
  $IF(DECOMP='B')
$REM    $HELP
$REM       TYPE OF DECOMPOSITION
$REM         1 - BUNCH-PARLETT DECOMPOSITION WITH NUMERICAL PERMUTATIONS
$REM         2 - BUNCH-KAUFMAN DECOMPOSITION WITH NUMERICAL PERMUTATIONS
$REM         3 - BUNCH PARLETT DECOMPOSITION WITH TWO LEVEL INDICES
$REM    $CHECK(MOS2,1,'1\2\3',2)
  $ELSEIF(DECOMP='P')
    $CONS='R'
    $SN='SN'
  $ENDIF
  $IF(TYPE='G')
    $HELP
      CHOICE OF THE VARIABLE METRIC UPDATE AFTER ZERO STEP:
        0 - NO UPDATE
        1 - NORMAL UPDATE
    $CHECK(MOT3,0,'0\1',4)
    $MOS1=0
  $ELSE
    $HELP
      CHOICE OF THE INITIAL STEPSIZE:
        1-UNIT INITIAL STEPSIZE
        2-COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
          STEPSIZE FOR VM METHODS
        3-COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
          STEPSIZE FOR CG METHODS
        4-QUADRATICALLY ESTIMATED INITIAL STEPSIZE
    $CHECK(INITS,2,'1\2\3\4',4)
    $DEFAULT=2
    $IF(MODEL='AM') $DEFAULT=1
    $IF($DEF(KSF))
      $IF(KSF=3) $DEFAULT=1
    $ENDIF
    $HELP
      SWITCH FOR TERMINATION OF LINE SEARCH:
        1 - NORMAL TERMINATION
        2 - SPECIAL TERMINATION FOR NONCONVEX FUNCTIONS
        3 - TERMINATION AFTER AT LEAST TWO STEPS
            (ASYMPTOTICALLY PERFECT LINE SEARCH)
    $CHECK(MES2,DEFAULT,'1\2\3',4)
  $ENDIF
  $HELP
    CHOICE OF THE INITIAL APPROXIMATION OF THE HESSIAN
    MATRIX:
      0 - INITIAL APPROXIMATION IS SPECIFIED IN THE CALLING
          PROGRAM
      1 - UNIT INITIAL APPROXIMATION
      2 - RANDOM INITIAL APPROXIMATION
      3 - NUMERICAL INITIAL APPROXIMATION
  $CHECK(INITH,1,'0\1\2\3',4)
  $IF(DECOMP='M')
    $IF(TYPE='L') $UPDATE='B'
    $HELP
      TYPE OF UPDATE
        B - BROYDEN CLASS OF UPDATES
        P - THE POWELL SYMMETRIC BROYDEN UPDATE
    $CHECK(UPDATE,'B','B\P',3,NO)
  $ELSEIF(DECOMP='I')
    $HELP
      TYPE OF UPDATE
        B - BROYDEN CLASS OF UPDATES
        D - BROYDEN CLASS OF UPDATES WITH DAVIDON PROJECTIONS
        L - DAVIDON CLASS OF UPDATES
        M - MULTI-STEP BROYDEN CLASS OF UPDATES
        S - SHIFTED BROYDEN CLASS OF UPDATES
    $CHECK(UPDATE,'B','B\D\L\S\M',3,NO)
    $IF(UPDATE='L') $INITH=1
    $IF(UPDATE='D') $INITH=1
  $ELSEIF(DECOMP='P')
    $UPDATE='B'
    $INITH=1
  $ELSE
    $HELP
      TYPE OF UPDATE
        B - BROYDEN CLASS OF UPDATES
        D - BROYDEN CLASS OF UPDATES WITH DAVIDON PROJECTIONS
        L - DAVIDON CLASS OF UPDATES
    $CHECK(UPDATE,'B','B\D\L',3,NO)
  $ENDIF
  $IF(UPDATE='B')
    $IF(DECOMP='M')
      $HELP
        METHOD OF UPDATE OF HESSIAN MATRIX:
          1 - BFGS UPDATE
          2 - DFP UPDATE
          3 - HOSHINO UPDATE
          4 - RANK-ONE UPDATE
      $CHECK(MET,1,'1\2\3\4',3)
    $ELSEIF(DECOMP='P')
      $MET=1
    $ENDIF
    $IF(DECOMP='I')
      $IF(CONSTR='U')
        $HELP
          COMPUTATION OF THE DIRECTION VECTOR:
            0 - USING MATRIX MULTIPLICATION
            1 - USING VARIABLE METRIC UPDATE
        $CHECK(MOS5,0,'0\1',3)
      $ELSE
        $MOS5=0
      $ENDIF
    $ELSE
      $MOS5=0
    $ENDIF
  $ELSEIF(UPDATE='M')
    $HELP
      METHOD OF UPDATE OF HESSIAN MATRIX:
        1 - BFGS UPDATE
        2 - DFP UPDATE
        3 - HOSHINO UPDATE
        4 - SAFEGUARDED RANK ONE UPDATE
        5 - OPTIMALLY CONDITIONED UPDATE
        6 - SIMPLE PRECONVEX UPDATE
        7 - VARIATIONALLY DERIVED PRECONVEX UPDATE
        8 - NEW COMBINED UPDATE
    $CHECK(MET,8,'1\2\3\4\5\6\7\8',3)
  $ELSEIF(UPDATE='L')
    $IF(DECOMP='I')
      $IF(CONSTR='U')
        $HELP
          COMPUTATION OF THE DIRECTION VECTOR:
            0 - USING MATRIX MULTIPLICATION
            1 - USING VARIABLE METRIC UPDATE
        $CHECK(MOS5,0,'0\1',3)
      $ELSE
        $MOS5=0
      $ENDIF
    $ELSE
      $MOS5=0
    $ENDIF
  $ENDIF
  $HELP
    MATRIX AFTER AN UNSUCCESSFUL UPDATE:
      0 - RESTART IS NOT USED
      1 - RESTART IS USED
  $CHECK(KTERH,0,'0\1',3)
  $HELP
    CORRECTION OF APPROXIMATION OF HESSIAN MATRIX
    AFTER CHANGE OF BASIS:
      1 - RESTART
      2 - CORRECTION
  $CHECK(MLC,2,'1\2',3)
  NDECF=0
  $SUBST('UO0FU1')
  $SUBST('UZLIND')
  $IF(NAL>0)
    $MAL=NAL
     MAL=NAL
    $JOB=1
    $IF(NORMA>0) $SUBST('UANRL1')
  $ENDIF
  $IF(NCL>0)
    $MCL=NCL
     MCL=NCL
    $ISNC=3
    $ADD(INIT)
      ISNC=3
    $ENDADD
    $JOB=1
    $IF(NORMC>0) $SUBST('UCNRL1')
    $IF(NORMF>0) $SUBST('UCTRL1')
    $SUBST('UCLNF2')
  $ENDIF
*
*     ----------------------
*     VARIABLE METRIC METHOD
*     TEMPLATE : U1FDU1
*     ----------------------
*
  $LMD=$10
  ASSIGN $30 TO IMD
  CALL UYPRO1('UXFU',1)
  CALL UYPRO2(FMIN,FO)
  $IF(DECOMP='P')
    $IF(CONSTR='U')
      N=NF
      CALL UXDCMI(NF,N,CZ)
    $ELSE
      $SUBST('UYFP$(CONSTR)1')
    $ENDIF
    IDECF=-1
    KIT=LIT+1
  $ELSEIF(CONSTR<>'U')
    $SUBST('UYFP$(CONSTR)1')
    IDECF=-1
  $ENDIF
$L=$10 ; $LABEL
  $KD=1 ; $IF(INITH=3) $KD=2
  $SUBST('UZMODN')
  $IF(KDS<1)
  $ELSE
    IF (TSS(NS).EQ.'USXX') P=UXVDOT(NF,$G,$S)
  $ENDIF
  GO TO IMD
$L=$ 30 ; $LABEL
  $SUBST('UYTR$(CONS)G')
  $SUBST('UO2FU3')
  $SUBST('UYFUT1')
  IF(ITERM.NE.0) GOTO $90
  $IF(CONSTR<>'U')
    $IF(MLC=1)
      $SUBST('UYRM$(CONSTR)0')
    $ELSEIF(DECOMP='P')
      $SUBST('UYRM$(CONSTR)0')
    $ELSE
      $SUBST('UYRM$(CONSTR)1')
    $ENDIF
  $ENDIF
$L=$ 40 ; $LABEL
  $IF(UPDATE='S')
    IF (IREST.GT.0) THEN
    PAR=ONE
    CALL UXDSMO($N,ZERO,$H)
    IDECF=-1
    CALL UYSET3
    ENDIF
  $ELSEIF(DECOMP='P')
    $SUBST('UUDSD6')
  $ELSE
    ASSIGN $40 TO IMD
    $SUBST('UUDSD1')
    GOTO ($50,$10) ISB+1
$L=$ 50 ; $LABEL
  $ENDIF
    IF(ITERM.NE.0) GOTO $90
  $IF($DEF(MCG))
    $IF(MCG<>0)
      $IF(MCG1=1)
        $SUBST('UYCP$(CON)D')
      $ENDIF
    $ENDIF
  $ENDIF
  $IF(DECOMP<>'P') $SUBST('UYTR$(CONSTR)H')
  $MAT='G'
  $DEC=DECOMP
  $DECOMG=DEC
  $IF(NUMBER=1)
    $DECOMG='G'
    $IF(DEC='M')
$REM      $HELP
$REM         TYPE OF DECOMPOSITION
$REM           0 - NO DECOMPOSITION
$REM           1 - GILL-MURRAY DECOMPOSITION
$REM           2 - SCHNABEL-ESKOW DECOMPOSITION
$REM      $CHECK(MOS2,1,'0\1\2',2)
$REM      $IF(MOS2=0) $DEC='M'
$REM      $IF(MOS2=1) $DEC='G'
$REM      $IF(MOS2=2) $DEC='S'
    $ELSEIF(DEC='I')
      $IF(UPDATE='B')
        $MAT='D'
        $DECOMG=DEC
      $ELSEIF(UPDATE='M')
        $MAT='D'
        $DECOMG=DEC
      $ELSEIF(UPDATE='L')
        $MAT='D'
        $DECOMG=DEC
      $ENDIF
    $ELSEIF(DEC='P')
      $MAT='D'
      $DECOMG=DEC
    $ENDIF
  $ENDIF
*
*     -----------------------
*     DIRECTION DETERMINATION
*     TEMPLATE : UD$(MAT)$(TYPE)$(DECOMG)$(NUMBER)
*     -----------------------
*
  $SUBST('UD$(MAT)$(TYPE)$(DECOMG)$(NUMBER)')
*
*     ------------------------------
*     END OF DIRECTION DETERMINATION
*     ------------------------------
*
  $IF(UPDATE='S')
    CALL UXVDIR($N,-PAR,$GN,$SN,$SN)
    SNORM=SQRT(UXVDOT(N,$SN,$SN))
  $ENDIF
$REM  $TYPES=TYPE
$REM  $IF(TYPE='T') $TYPE='G'
  $IF(DECOMP='P')
    $SUBST('UD1T$(TYPE)5')
  $ELSE
    $SUBST('UD1T$(TYPE)1')
  $ENDIF
  IF(ITERM.NE.0) GOTO $90
  IF(IREST.NE.0) GOTO $40
  $SUBST('UYTR$(CONS)S')
$REM  $IF(CONSTR='U')
$REM    $IF(DECOMP='P')
$REM      CALL UXDCMM(NF,N,$CZ,$SN,$S)
$REM    $ENDIF
$REM  $ELSE
$REM    IF (RMAX.LE.ZERO) GO TO $75
$REM  $ENDIF
$L=$ 70 ; $LABEL
  ASSIGN $70 TO IMD
  $SUBST('UZLINS')
  GOTO ($74,$72) ISB+1
$L=$ 72 ; $LABEL
  CALL UXVDIR(NF,R,$S,$XO,$X)
  GOTO $10
$L=$ 74 ; $LABEL
  IF (ITERS.LE.0) THEN
  $IF(KDS<1)
    $SUBST('UYZER0')
  $ELSE
    $SUBST('UYZER1')
  $ENDIF
  IF(IDIR.EQ.0) THEN
  CALL UYRES1(TSXX)
  CALL UYSET1
  GO TO $40
  ELSE IF (MOT3.EQ.0) THEN
  CALL UYSET1
  GO TO $40
  ELSE
  ITERD=0
  ENDIF
  ENDIF
  IF(KD.GT.LD) THEN
  ASSIGN $80 TO IMD
  GO TO $10
  ENDIF
$L=$ 80 ; $LABEL
  TXFU=TUXX
  $IF($DEF(MCG))
    $IF(MCG<>0)
      $IF(MCG1=1)
        $SUBST('UYUP$(CON)D')
      $ENDIF
    $ENDIF
  $ENDIF
  $SUBST('UYTR$(CONS)D')
$REM  $SUBST('UYTR$(CONSTR)D')
$REM  $IF(CONSTR='U')
$REM    $IF(DECOMP='P')
$REM      CALL UXVCOP(NF,$XO,$S)
$REM      CALL UXVSCL(N,R,$SN,$XO)
$REM     CALL UXVCOP(NF,$GO,$SN)
$REM      CALL UXDRMM(NF,N,$CZ,$SN,$GO)
$REM    $ENDIF
$REM  $ENDIF
  $DECOMG='G'
  $IF(DEC='I') $DECOMG=DEC
  $IF(DEC='P') $DECOMG=DEC
  $SUBST('UUD$(UPDATE)$(DECOMG)1')
  $IF(DEC='G') $KHLP=1
  $IF(DEC='M') $KHLP=4
  $IF(DEC='I') $KHLP=4
  $IF(DEC='P') $KHLP=5
  $IF(MLC=1) $KHLP=0
  $IF(CONSTR<>'U')
$L=$75 ; $LABEL
    IF (IDIR.EQ.0) THEN
    $SUBST('UYAD$(CONSTR)$(KHLP)')
    ENDIF
  $ENDIF
  IF(IDIR.EQ.0) THEN
  IF(ITERH.NE.0.AND.KTERH.NE.0) CALL UYRES1('UPDATE  ')
  GOTO $30
  ELSE
  GOTO $40
  ENDIF
$L=$ 90 ; $LABEL
  $IF(CONSTR<>'U')
    $IF(KBF>0)
      CALL UXVINA(NX,IX)
    $ENDIF
    $IF(KBC>0)
      CALL UXVINA(NC,IC)
    $ENDIF
  $ENDIF
  IF(ITERM.LT.0) TXFU=TDXX
  CALL UYEPI1(1)
  $IF(NAL>0)
    $JOB=-1
    $IF(NORMA>0) $SUBST('UANRL1')
  $ENDIF
  $IF(NCL>0)
    $JOB=-1
    $IF(NORMF>0) $SUBST('UCTRL1')
    $IF(NORMC>0) $SUBST('UCNRL1')
  $ENDIF
  $SUBST('UO1FU2')
$REM  $TYPE=TYPES
  $ADD(INIT)
    NXFU='U1FDU1'
  $ENDADD
  $EXIT
