$INTERFACE U2FDN1                                             97/12/01
$REM LU
  $N='N'
  $NN='NC'
  $CZS='CZ'
  $ADD(REAL,'\UXVDOT')
  $ADD(REAL,'\$CFO($NC+1)')
  $ADD(INTEGER,'\IMD\LDS')
  $HELP
    TYPE OF METHOD:
      L - LINE SEARCH
      G - GENERAL TRUST REGION
      C - GENERAL TRUST REGION WITH SECOND ORDER CORRECTION
  $CHECK(TYPE,'L','L\G\C',2,NO)
  $SUBP='Q'
  $DECOMP=SUBP
  $UPDATE='NO'
  $HELP
    QUADRATIC PROGRAMMING METHOD:
      1 - DUAL QUADRATIC PROGRAMMING METHOD
      2 - PRIMAL QUADRATIC PROGRAMMING METHOD
  $CHECK(NUMBER,'1','1\2',2,NO)
  $HELP
    MERIT FUNCTION
      1 - L1 PENALTY FUNCTION
      2 - HESTENES AUGMENTED LAGRANGIAN FUNCTION
      3 - L1 AUGMENTED LAGRANGIAN FUNCTION
  $CHECK(MEP,3,'1\2\3',2)
  $IF(MEP=1)
    $HELP
      PENALTY COEFFICIENT (IT MUST BE GREATER THEN ONE)
    $CHECK(RPF2,'0.5$P 0',REAL,3)
$REM    $ADD(SINID)
$REM      CALL UXVSET(NC,ZERO,$CP)
$REM    $ENDADD
  $ELSEIF(MEP=2)
    $HELP
      PENALTY COEFFICIENT
    $CHECK(RPF2,'0.5$P 0',REAL,3)
  $ELSEIF(MEP=3)
    $HELP
      PENALTY COEFFICIENT
    $CHECK(RPF2,'0.5$P 0',REAL,3)
  $ENDIF
  $ISNC=2
  $ADD(INIT)
    ISNC=2
  $ENDADD
  $ADD(SINID)
    N=NF
    CALL UXVSET(NC,ZERO,$CP)
  $ENDADD
  $IF(TYPE='L')
    $KDS=0
    $HELP
      LINE SEARCH INTERPOLATION
        1 - BISECTION
        2 - TWO POINT QUADRATIC INTERPOLATION
        3 - THREE POINT QUADRATIC INTERPOLATION
        4 - THREE POINT CUBIC INTERPOLATION
        5 - SPECIAL INTERPOLATION
    $CHECK(MES,1,'1\2\3\4\5',3)
    $STEP=1
    $IF(MES=5) $STEP=6
    $HELP
      CHOICE OF THE INITIAL STEPSIZE:
        1-UNIT INITIAL STEPSIZE
        2-COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
          STEPSIZE FOR VM METHODS
        3-COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
          STEPSIZE FOR CG METHODS
        4-QUADRATICALLY ESTIMATED INITIAL STEPSIZE
    $CHECK(INITS,1,'1\2\3\4',4)
    $LCS=0
  $ELSE
    $IXA='IXA'
    $NX=NF
    $LCS=1
    $ADD(INIT)
      LCS=1
      INITS=-1
    $ENDADD
    $ADD(SINID)
      $SUBST('UYINV1')
      CALL UXVINS(NF,-1,$IXA)
    $ENDADD
  $ENDIF
  $HELP
    CHOICE OF THE INITIAL APPROXIMATION OF THE HESSIAN
    MATRIX:
      0 - INITIAL APPROXIMATION IS SPECIFIED IN THE CALLING
          PROGRAM
      1 - UNIT INITIAL APPROXIMATION
      2 - RANDOM INITIAL APPROXIMATION
  $CHECK(INITH,1,'0\1\2',4)
  $HELP
    PENALTY PARAMETER
  $CHECK(RPF1,'5.0$P 0',REAL,4)
  $MCL=NC
   MCL=NC
  $GN=GP
  $SN=S
  NDECF=0
  $SUBST('UO0FU1')
  $SUBST('UZLIND')
  $IF(NCL>0)
    $JOB=1
    $IF(NORMC>0) $SUBST('UCNRL1')
    $IF(NORMF>0) $SUBST('UCTRL1')
  $ENDIF
  $IF (KBF>0) $SUBST('UYFPS1')
*
*     ----------------------------------------------
*     RECURSIVE QUADRAQTIC PROGRAMMING NEWTON METHOD
*     TEMPLATE : U2FDN1
*     ----------------------------------------------
*
  $LMD=$10
  ASSIGN $30 TO IMD
  CALL UYPRO1('UXFU',2)
  CALL UYPRO3(0)
  MOT=0
  T=ZERO
  FO=FMIN
$L=$10 ; $LABEL
  $KD=2
  LDS=LD
  $SUBST('UZMODN')
  LD=LDS
  $SUBST('UC2F01')
  CF(NC+1)=F
  IF (TSS(NS).EQ.'USXX') THEN
  $IF(MEP=1)
    $SUBST('UP0SA9')
  $ELSEIF(MEP=2)
    $SUBST('UP0AF9')
  $ELSEIF(MEP=3)
    $SUBST('UP0AF8')
  $ENDIF
  $IF(LCS=1) $SUBST('UPPRE2')
  $IF(KDS<1)
  $ELSE
    P=UXVDOT(NF,$GP,$S)
  $ENDIF
  ENDIF
  GO TO IMD
$L=$ 30 ; $LABEL
  $SUBST('UO2FN3')
  $SUBST('UYFUT2')
  IF(ITERM.NE.0) GOTO $90
$L=$ 40 ; $LABEL
  N=NF
  $GO=G
  $G=GP
  $SUBST('UUDSD1')
  IF (ITERM.NE.0) GO TO $90
  $IF($DEF(MCG))
    $IF(MCG<>0)
      $IF(MCG1=1)
        $SUBST('UYCP$(CON)D')
      $ENDIF
    $ENDIF
  $ENDIF
  CALL UXVCOP(NC+1,$CF,$CFO)
*
*     -----------------------
*     DIRECTION DETERMINATION
*     TEMPLATE : UDDS$(SUBP)1
*     -----------------------
*
  $SUBST('UDDS$(SUBP)1')
*
*     ------------------------------
*     END OF DIRECTION DETERMINATION
*     ------------------------------
*
  $GO='GO'
  CALL UXVCOP(NC+1,$CFO,$CF)
  $SUBST('UD1T$(TYPE)2')
  IF (GMAX.LE.TOLG.AND.CMAX.LE.TOLC) THEN
  ITERM=4
  TXFU='GRAD TOL'
  ENDIF
  IF(ITERM.NE.0) GOTO $90
  IF(IREST.NE.0) GOTO $40
  $SUBST('UPSET2')
  $IF($DEF(MES))
    $IF(MES=5)
      $CFD(NC+1)=UXVDOT(NF,$GF,$S)
      $SUBST('UCMAXD')
    $ENDIF
  $ELSEIF(LCS=1)
    $CFD(NC+1)=UXVDOT(NF,$GF,$S)
    $SUBST('UCMAXD')
  $ENDIF
  CALL UXVINA(NC,$IC)
  $IF(MEP=1)
    $SUBST('UP0SA9')
  $ELSEIF(MEP=2)
    $SUBST('UP0AF9')
  $ELSEIF(MEP=3)
    $SUBST('UP0AF8')
  $ENDIF
  $IF(LCS=1) $SUBST('UPPRE2')
  $GO='GO'
  $SUBST('UYTRUS')
  CALL UXVCOP(NC+1,$CF,$CFO)
  CALL UXVCOP(NF,$GF,$CR)
$L=$ 60 ; $LABEL
  ASSIGN $60 TO IMD
  $SUBST('UZLINS')
  $IF(TYPE='C')
    $GOTO ($74,$72,$70) ISB+1
$L=$ 70 ; $LABEL
    $CZS='CZS'
    $SUBST('UYSETC')
*
*     --------------------------------
*     BEGIN OF DIRECTION DETERMINATION
*     --------------------------------
*
    $SUBST('UDDS$(SUBP)1')
*
*     ------------------------------
*     END OF DIRECTION DETERMINATION
*     ------------------------------
*
    P=UXVDOT(NF,$G,$S)
    GO TO $60
  $ELSE
    GOTO ($74,$72) ISB+1
  $ENDIF
$L=$ 72 ; $LABEL
  CALL UXVDIR(NF,R,$S,$XO,$X)
  GOTO $10
$L=$ 74 ; $LABEL
  IF (ITERS.LE.0) THEN
  $IF(KDS<1)
    $SUBST('UYZER0')
  $ELSE
    $SUBST('UYZER1')
  $ENDIF
  CALL UXVCOP(NC+1,$CFO,$CF)
  CALL UXVCOP(NF,$CR,$GF)
  IF(IDIR.EQ.0) THEN
  CALL UYRES1(TSXX)
  CALL UYSET1
  GO TO $40
  ELSE IF (MOT3.EQ.0) THEN
  CALL UYSET1
  GO TO $40
  ELSE
  ITERD=0
  ENDIF
  ENDIF
  IF(KD.GT.LD) THEN
  ASSIGN $80 TO IMD
  GO TO $10
  ENDIF
$L=$ 80 ; $LABEL
  TXFU=TUXX
  TUXX='NEWTON  '
  $IF(SUBP='Q')
    CALL UXVCOP(NF,$GF,$G)
    $SUBST('UYTRED')
    $IF($DEF(MCG))
      $IF(MCG<>0)
        $IF(MCG1=1)
          $SUBST('UYUPND')
        $ENDIF
      $ENDIF
    $ENDIF
  $ENDIF
  GOTO $30
$L=$ 90 ; $LABEL
  IF(ITERM.LT.0) TXFU=TDXX
  CALL UYEPI1(1)
  $IF(NCL>0)
    $JOB=-1
    $IF(NORMF>0) $SUBST('UCTRL1')
    $IF(NORMC>0) $SUBST('UCNRL1')
  $ENDIF
  $SUBST('UO1FN2')
  $ADD(INIT)
    NXFU='U2FDN1'
  $ENDADD
  $EXIT
