$INTERFACE UDDBQ2                                             97/12/01
$REM VL
  $AH='AH'
  $HH='HH'
  $G=GH
  $HF=H
  $H=HH
  $HELP
    LOCALITY MEASURE EXPONENT (SEE MANUAL UFO)
      1 - EXPONENT ONE
      2 - EXPONENT TWO
  $CHECK(MOS3,2,'1\2',3)
  $HELP
    MAXIMUM STEPSIZE
  $CHECK(XMAX,'1.0$P 3',REAL,2)
  $HELP
    INITIAL TRUST REGION BOUND
  $CHECK(XDEL,XMAX,REAL,3)
  $HELP
    TOLERANCE FOR NEAR ACTIVITY
  $CHECK(ETA4,'1.0$P 0',REAL,4)
  $ADD(REAL,'\$AF(5*($MA))\$H($M)\$S($NF+1)\$GH($NF)&
  \$HH($NF*($NF+1)/2)\$AH($NF*($NF+1)/2*($MA))\$H($NF*($NF+1)/2)&
  \$AG($NF*($MA))\$GO($NF)\$AZ($NF+1)\$AFD($MAL)')
  $ADD(INTEGER,'\$IXA($NF)\$IA($MA)\$IAA($NF+1)')
  $ADD(REAL,'\UXVDOT\UXVMAX\UXDSMQ')
  $ADD(REAL,'\DELF\FS\FU\PU\WK\FV\PV')
  $ADD(INTEGER,'\I\J\K\L\NFF\IPOC\IND\IEXTS')
  $ADD(LOGICAL,'\LQ\LA')
  NFF=NF*(NF+1)/2
  I=MA*4
*
*     INITIALIZATION
*
  IF (NIT.LE.LIT+1) THEN
  CALL UXVCOP(NF,$G,$GO)
  CALL UXVCOP(NF,$GO,$AG(1))
  CALL UXVCOP(NFF,$HF,$H)
  RP=ZERO
  R=ZERO
  FP=F
  FU=ZERO
  PU=ZERO
  $IA(1)=2
  MAL=0
  IPOC=0
  IND=0
  WK=ZERO
  ENDIF
*
*     NULL STEPS COUNTER
*
  IPOC=IPOC+1
  IF (ITERS.NE.10) IPOC=0
  LQ=IPOC.LE.3
*
*     BUNDLE VALUES LINEAR UPDATE
*
  DO $20 KA=1,MAL
  $AF(MA+MA+KA)=$AF(MA+MA+KA)+RP*SNORM
$20 CONTINUE
  $SUBST('UASET4')
  CALL UXVDIR(MAL,RP,$AFD,$AF(MA+1),$AF(MA+1))
  PU=PU+RP*SNORM
  FU=FU+RP*UXVDOT(NF,$AG,$S)
*
*     DAMPING PARAMETER DETERMINATION
*
  FS=F
  PP=ONE
  IF (RP.NE.R) THEN
  FS=FS+(RP-R)*P
  FV=FS+HALF*(RP-R)**2*UXDSMQ(NF,$HF,$S,$S)
  LA=(FV.GT.FS).AND.(FV.GT.FP)
  IF (LA) PP=MAX(ZERO,(FP-FS)/(FV-FS))
  IF (LQ) FS=FS+PP*(FV-FS)
  ELSE IF (IND.GT.1) THEN
  PV=$AF(MA+IND)
  FV=PV+HALF*R*R*UXDSMQ(NF,$AH((IND-1)*NFF+1),$S,$S)
  LA=(FV.GT.PV).AND.(FV.GT.FP)
  IF (LA) PP=MAX(ZERO,(FP-PV)/(FV-PV))
  ENDIF
*
*     BUNDLE VALUES  F  QUADRATIC UPDATE
*
  PV=UXDSMQ(NF,$AH,$S,$S)
  CALL UXVCOP(NFF,$H,$AH)
  DO $11 KA=1,MAL
  $AF(MA+KA)=$AF(MA+KA)+$AF(I+KA)*HALF*RP*RP*&
  UXDSMQ(NF,$AH(1+(KA-1)*NFF),$S,$S)
$11 CONTINUE
  IF (RP.EQ.R.AND.IND.GT.1) $AF(I+IND)=PP
*
*     FU  CORRECTION - COMPUTATION WITH NEW AGGREGATE MATRIX
*
  FU=FU+$AF(I+1)*HALF*RP*RP*(UXDSMQ(NF,$AH,$S,$S)*(ONE+WK)-WK*PV)
*
*     BUNDLE REDUCTION
*
  DO $22 L=MAL,1,-1
  IF ($IA(L).NE.0) GO TO $22
  K=(L-1)*NF+1
  DO $23 KA=L,MAL-1
  $AF(MA+KA)=$AF(MA+KA+1)
  $AF(MA+MA+KA)=$AF(MA+MA+KA+1)
  $AF(MA*3+KA)=$AF(MA*3+KA+1)
  $AF(I+KA)=$AF(I+KA+1)
  $IA(KA)=$IA(KA+1)
  CALL UXVCOP(NF,$AG(K+NF),$AG(K))
  CALL UXVCOP(NFF,$AH(L*NFF+1),$AH(L*NFF+1-NFF))
  K=K+NF
$23 CONTINUE
  IND=IND-1
  MAL=MAL-1
$22 CONTINUE
  IF (MAL.GE.MA) THEN
  K=1+NF
  L=1+NFF
  DO $50 KA=2,MAL-1
  $AF(MA+KA)=$AF(MA+KA+1)
  $AF(MA+MA+KA)=$AF(MA+MA+KA+1)
  $AF(MA*3+KA)=$AF(MA*3+KA+1)
  $AF(I+KA)=$AF(I+KA+1)
  $IA(KA)=$IA(KA+1)
  CALL UXVCOP(NF,$AG(K+NF),$AG(K))
  CALL UXVCOP(NFF,$AH(L+NFF),$AH(L))
  K=K+NF
  L=L+NFF
$50 CONTINUE
  IND=IND-1
  MAL=MAL-1
  ENDIF
*
*     BUNDLE COMPLETION
*
  MAL=MAX(2,MAL+1)
  K=(MAL-1)*NF+1
  L=(MAL-1)*NFF+1
  $AF(MA+1)=FU
  $AF(MA+MAL)=FS
  $AF(MA+MA+1)=PU
  $AF(MA+MA+MAL)=(R-RP)*SNORM
  $AF(MA*3+MAL)=SQRT(UXVDOT(NF,$G,$G))
  $AF(I+1)=ONE
  DO $60 KA=1,MAL
  $AF(KA)=-MAX(ABS($AF(MA+KA)-FP),ETA5*ABS($AF(MA+MA+KA))**MOS3)
$60  CONTINUE
  DO $16 KA=0,MAL-2
  CALL UXDSMM(NF,$AH(1+KA*NFF),$S,$AH(L))
  CALL UXVDIR(NF,RP*$AF(I+KA+1),$AH(L),$AG(1+KA*NF),$AG(1+KA*NF))
$16 CONTINUE
  CALL UXVCOP(NF,$G,$AG(K))
  IF (R.EQ.RP) THEN
  $AF(I+MAL)=ONE
  IND=MAL
  ELSE
  $AF(I+MAL)=PP
  IF (.NOT.LQ) $AF(I+MAL)=ZERO
  CALL UXDSMM(NF,$HF,$S,$AH(L))
  CALL UXVDIR(NF,(RP-R)*$AF(I+MAL),$AH(L),$AG(K),$AG(K))
  ENDIF
  CALL UXVCOP(NFF,$HF,$AH(L))
  $IA(MAL)=2
*
*     MAIN STOPPING CRITERION - SEE ALSO UYFUT4
*
  F=FP
  IF (ITERS.LE.0) F=FO
  WK=HALF*GNORM*SNORM+5.0$P 1*MAX(ABS(FU-FP),ETA5*PU*PU)/(ABS(FP)&
  +1.0$P-3)
  IF (NIT.LE.1) WK=ONE
  IF (WK.LE.TOLG) THEN
  ITERM=4
  TXFU='GRAD TOL'
  NIT=NIT-1
  GO TO $99
  ENDIF
  CALL UXVCOP(NFF,$H,$HF)
*
*     OLD SUBROUTINE UDDXQ2 - QUADRATIC PROGRAMMING METHOD
*
  IF (NTESX.GT.0.AND.NTESX.LT.NTESF) NTESF=NTESX
  IF (NIT-LIT.LE.1) DELF=ONE
  IF (FO.NE.F) DELF=ABS(FO-F)/MAX(ABS(F),ONE)
  CALL UOD1D1
  MFP=2
  MODE=1
$30 CONTINUE
  $G=GO
  $H=HF
  $JOB=1
  $QPCON='F'
  $IF(MCL=0) $QPCON='A'
  IEXTS=IEXT
  IEXT=-1
  $IF(NUMBER=1)
    $SUBST('ULQD$(QPCON)1')
  $ELSE
    $SUBST('ULQP$(QPCON)2')
  $ENDIF
  IEXT=IEXTS
  $H=HH
  IF (ITERQ.LT. 0) THEN
  IF (ITERQ.EQ.-1) THEN
  TDXX='NON FEAS'
  ELSE
  TDXX='INVALID '
  ENDIF
  ITERD=-2
  GO TO $70
  ENDIF
  ITERD=1
  TDXX='QD STEP '
  GMAX=UXVMAX(NF,$GO)
  IF (LCS.GT.0) THEN
  GNORM=GMAX
  SNORM=UXVMAX(NF,$S)
  ELSE
  GNORM=SQRT(UXVDOT(NF,$GO,$GO))
  SNORM=SQRT(UXVDOT(NF,$S,$S))
  ENDIF
  IF (DELF.LE.TOLF.OR.ABS(FO-F)/MAX(ABS(F),ONE).GT.ONE) THEN
  ELSE IF (GNORM.LT.TOLG*TOLG*UXVMAX(MAL-1,$AF(MA*3+2))) THEN
  J=MAL
  DO $21 KA=MAL,1,-1
  IF ($IA(KA).LT.0) J=KA
$21 CONTINUE
  IF (J.EQ.MAL) GO TO $70
  $IA(J)=0
  GO TO $30
  ENDIF
$70 CONTINUE
  IF (LCS.GT.0) THEN
  DO $80 J=1,NF
  IF ($IXA(J).GE.0) ITERD=3
$80 CONTINUE
  ENDIF
*
*     AGGREGATION
*
  FU=ZERO
  PU=ZERO
  IF (NF.GT.N) CALL UXVSET(NFF,ZERO,$H)
  K=0
  DO $90 KA=1,NF-N
  L=$IAA(KA)
  IF (L.GT.MCL) THEN
  L=L-MCL
  FU=FU-AZ(KA)*$AF(MA+L)
  PU=PU-AZ(KA)*$AF(MA+MA+L)
  CALL UXVDIR(NFF,-AZ(KA)*$AF(I+L),$AH((L-1)*NFF+1),$H,$H)
  IF(L.EQ.1)K=KA
  ENDIF
$90 CONTINUE
  CALL UXVCOP(NF,$GO,$AG)
*
*     CORRECTION FACTOR FOR  FU  (FIRST LAGRANGE MULTIPLIER, IF ACTIVE)
*
  WK=ZERO
  IF(K.GT.0) WK=-AZ(K)
*
*     PREPARATION FOR UYTRXD - TEST VALUES DETERMINATION
*
  FUB=FP
$99 CALL UOD1D2(NF,$GO,$S)
  $ADD(SINID)
    CALL UXVSET(NF*(NF+1)/2,ZERO,AH)
  $ENDADD
  $ADD(INIT)
    NDXX='UDDBQ2'
  $ENDADD
  $EXIT
