$INTERFACE UDDBQ3                                             97/12/01
$REM VL
  $G=GH
  $HELP
    LOCALITY MEASURE EXPONENT (SEE MANUAL UFO)
      1 - EXPONENT ONE
      2 - EXPONENT TWO
  $CHECK(MOS3,2,'1\2',3)
  $HELP
    MAXIMUM STEPSIZE
  $CHECK(XMAX,'1.0$P 3',REAL,2)
  $HELP
    INITIAL TRUST REGION BOUND
  $CHECK(XDEL,XMAX,REAL,3)
  $HELP
    TOLERANCE FOR NEAR ACTIVITY
  $CHECK(ETA4,'1.0$P 0',REAL,4)
  $ADD(REAL,'\$AF(5*($MA))\$AZ($NF+1)\$S($NF+1)\$GH($NF)\$GO($NF)&
  \$AG($NF*($MA))\$H($NF*($NF+1)/2)\$XO($NF)\$X($NF)\$GS($NF)&
  \$AY($NF*($MA))')
  $ADD(INTEGER,'\$IXA($NF)\$IA($MA)\$IAA($NF+1)')
  $ADD(REAL,'\UXVDOT\UXVMAX\UXDPGQ')
  $ADD(REAL,'\DELF\FS\FU\PU\WK\FV\PV\TEMP\FPOM\PPOM')
  $ADD(INTEGER,'\I\J\K\L\NFF\IPOC\IND\NPOM\KPOM\IEXTS')
  $ADD(LOGICAL,'\LQ\LA\LPOM\LLIN')
  LLIN=.TRUE.
  NFF=NF*(NF+1)/2
  I=MA*4
*
*     INITIALIZATION
*
  IF (NIT.LE.LIT+1) THEN
  CALL UXVCOP(NF,$G,$GO)
  CALL UXVCOP(NF,$GO,$AG(1))
  RP=ZERO
  R=ZERO
  FP=F
  FU=ZERO
  PU=ZERO
  $IA(1)=2
  MAL=0
  IPOC=0
  IND=0
  WK=ZERO
  ENDIF
*
*     NULL STEPS COUNTER
*
  IPOC=IPOC+1
  IF (ITERS.NE.10) IPOC=0
  LQ=IPOC.LE.3
*
*     BUNDLE VALUES LINEAR UPDATE
*
  DO $20 KA=1,MAL
  $AF(MA+MA+KA)=$AF(MA+MA+KA)+RP*SNORM
$20 CONTINUE
  DO $24 KA=1,MAL
  $AF(MA+KA)=$AF(MA+KA)+RP*UXVDOT(NF,$AG(1+(KA-1)*NF),$S)
$24 CONTINUE
  PU=PU+RP*SNORM
  FU=FU+RP*UXVDOT(NF,$AG,$S)
  IF (IDECF.LT.0) IDECF=1
  IF (IDECF.EQ.0) THEN
*
*   GILL-MURRAY DECOMPOSITION
*
  TEMP=ETA2
  CALL UXDPGF(NF,$H,INF,TEMP,FS)
  NDECF=NDECF+1
  IDECF=1
  ENDIF
  IF (NIT.LE.LIT+1) GO TO $15
  CALL UXVDIR(NF,R-RP,$S,X,$AY(1+(MAL-1)*NF))
  CALL UXVCOP(NF,X,XO)
  CALL UXVCOP(NF,$G,$GS)
  FPOM=F
  PPOM=P
  CALL UXVSET(NF,ZERO,$GO)
  KPOM=1
$13 CONTINUE
  IF (KPOM.GT.NF-NPOM) GO TO $12
  L=$IAA(KPOM)
  LPOM=L.GT.MCL
  IF (LPOM) THEN
  L=L-MCL
  CALL UXVDIR(NF,R*1.0$P-3,$S,$AY(1+(l-1)*NF),X)
  LD=0
  KD=1
  ASSIGN $14 TO IMD
  GO TO $LMD
  ENDIF
$14 CONTINUE
  IF (LPOM) CALL UXVDIR(NF,-AZ(KPOM),$G,$GO,$GO)
  KPOM=KPOM+1
  GO TO $13
$12 CONTINUE
  CALL UXVCOP(NF,XO,X)
  F=FPOM
  P=PPOM
  CALL UXVSCL(NF,R*1.0$P-3,$S,XO)
  CALL UXVCOP(NF,$GO,$G)
  CALL UXVCOP(NF,$GS,$GO)
  IF (ITERS.GT.0) THEN
  CALL UXVDIF(NF,$G,$GO,$GO)
  ELSE
  CALL UXVSAV(NF,$G,$GO)
  ENDIF
  CALL UXVCOP(NF,$GS,$G)
  ITERD=2
  CALL UUDBG1($H,$G,$GS,XO,$GO)
$15 CONTINUE
  CALL UXVCOP(NF,$S,XO)
  CALL UXDPGM(NF,$H,XO,1)
  TEMP=UXDPGQ(NF,$H,XO,XO)
*
*     DAMPING PARAMETER DETERMINATION
*
  FS=F
  PP=ONE
  IF (RP.NE.R) THEN
  FS=FS+(RP-R)*P
  FV=FS+HALF*(RP-R)**2*TEMP
  LA=(FV.GT.FS).AND.(FV.GT.FP)
  IF (LA) PP=MAX(ZERO,(FP-FS)/(FV-FS))
  IF (LLIN) PP=ZERO
  IF (LQ) FS=FS+PP*(FV-FS)
  ELSE IF (IND.GT.1) THEN
  PV=$AF(MA+IND)
  FV=PV+HALF*R*R*TEMP
  LA=(FV.GT.PV).AND.(FV.GT.FP)
  IF (LA) PP=MAX(ZERO,(FP-PV)/(FV-PV))
  IF (LLIN) PP=ZERO
  ENDIF
*
*     BUNDLE VALUES QUADRATIC UPDATE
*
  IF (LLIN) $AF(I+1)=ZERO
  DO $11 KA=1,MAL
  $AF(MA+KA)=$AF(MA+KA)+$AF(I+KA)*HALF*RP*RP*TEMP
$11 CONTINUE
  FU=FU+$AF(I+1)*HALF*RP*RP*TEMP
  IF (RP.EQ.R.AND.IND.GT.1) $AF(I+IND)=PP
*
*     BUNDLE REDUCTION
*
  DO $22 L=MAL,1,-1
  IF ($IA(L).NE.0) GO TO $22
  K=(L-1)*NF+1
  DO $23 KA=L,MAL-1
  $AF(MA+KA)=$AF(MA+KA+1)
  $AF(MA+MA+KA)=$AF(MA+MA+KA+1)
  $AF(MA*3+KA)=$AF(MA*3+KA+1)
  $AF(I+KA)=$AF(I+KA+1)
  $IA(KA)=$IA(KA+1)
  CALL UXVCOP(NF,$AG(K+NF),$AG(K))
  K=K+NF
$23 CONTINUE
  IND=IND-1
  MAL=MAL-1
$22 CONTINUE
  IF (MAL.GE.MA) THEN
  K=1+NF
  DO $50 KA=2,MAL-1
  $AF(MA+KA)=$AF(MA+KA+1)
  $AF(MA+MA+KA)=$AF(MA+MA+KA+1)
  $AF(MA*3+KA)=$AF(MA*3+KA+1)
  $AF(I+KA)=$AF(I+KA+1)
  $IA(KA)=$IA(KA+1)
  CALL UXVCOP(NF,$AG(K+NF),$AG(K))
  K=K+NF
$50 CONTINUE
  IND=IND-1
  MAL=MAL-1
  ENDIF
*
*     BUNDLE COMPLETION
*
  MAL=MAX(2,MAL+1)
  K=(MAL-1)*NF+1
  $AF(MA+1)=FU
  $AF(MA+MAL)=FS
  $AF(MA+MA+1)=PU
  $AF(MA+MA+MAL)=(R-RP)*SNORM
  $AF(MA*3+MAL)=SQRT(UXVDOT(NF,$G,$G))
  $AF(I+1)=ONE
  IF (LLIN) $AF(I+1)=ZERO
  DO $60 KA=1,MAL
  $AF(KA)=-MAX(ABS($AF(MA+KA)-FP),ETA5*ABS($AF(MA+MA+KA))**MOS3)
$60 CONTINUE
  CALL UXVCOP(NF,$S,XO)
  CALL UXDPGM(NF,$H,XO,0)
  DO $16 KA=0,MAL-2
  CALL UXVDIR(NF,RP*$AF(I+KA+1),XO,$AG(1+KA*NF),$AG(1+KA*NF))
$16 CONTINUE
  CALL UXVCOP(NF,$G,$AG(K))
  IF (R.EQ.RP) THEN
  $AF(I+MAL)=ONE
  IF (LLIN) $AF(I+MAL)=ZERO
  IND=MAL
  ELSE
  $AF(I+MAL)=PP
  IF (.NOT.LQ) $AF(I+MAL)=ZERO
  CALL UXVDIR(NF,(RP-R)*$AF(I+MAL),XO,$AG(K),$AG(K))
  ENDIF
  $IA(MAL)=2
*
*     MAIN STOPPING CRITERION - SEE ALSO UYFUT4
*
  F=FP
  IF (ITERS.LE.0) F=FO
  WK=HALF*GNORM*SNORM+5.0$P 1*MAX(ABS(FU-FP),ETA5*PU*PU)&
  /(ABS(FP)+1.0$P-3)
  IF (NIT.LE.1) WK=ONE
  IF (WK.LE.TOLG) THEN
  ITERM=4
  TXFU='GRAD TOL'
  NIT=NIT-1
  GO TO $99
  ENDIF
*
*     OLD SUBROUTINE UDDXQ2 - QUADRATIC PROGRAMMING METHOD
*
  IF (NTESX.GT.0.AND.NTESX.LT.NTESF) NTESF=NTESX
  IF (NIT-LIT.LE.1) DELF=ONE
  IF (FO.NE.F) DELF=ABS(FO-F)/MAX(ABS(F),ONE)
  CALL UOD1D1
  MFP=2
  MODE=1
$30 CONTINUE
  $G=GO
  $JOB=1
  $QPCON='F'
  $IF(MCL=0) $QPCON='A'
  IEXTS=IEXT
  IEXT=-1
  $IF(NUMBER=1)
    $SUBST('ULQD$(QPCON)1')
  $ELSE
    $SUBST('ULQP$(QPCON)2')
  $ENDIF
  IEXT=IEXTS
  IF (ITERQ.LT. 0) THEN
  IF (ITERQ.EQ.-1) THEN
  TDXX='NON FEAS'
  ELSE
  TDXX='INVALID '
  ENDIF
  ITERD=-2
  GO TO $70
  ENDIF
  ITERD=1
  TDXX='QD STEP '
  GMAX=UXVMAX(NF,$GO)
  IF (LCS.GT.0) THEN
  GNORM=GMAX
  SNORM=UXVMAX(NF,$S)
  ELSE
  GNORM=SQRT(UXVDOT(NF,$GO,$GO))
  SNORM=SQRT(UXVDOT(NF,$S,$S))
  ENDIF
  IF (DELF.LE.TOLF.OR.ABS(FO-F)/MAX(ABS(F),ONE).GT.ONE) THEN
  ELSE IF (GNORM.LT.TOLG*TOLG*UXVMAX(MAL-1,$AF(MA*3+2))) THEN
  J=MAL
  DO $21 KA=MAL,1,-1
  IF ($IA(KA).LT.0) J=KA
$21 CONTINUE
  IF (J.EQ.MAL) GO TO $70
  $IA(J)=0
  GO TO $30
  ENDIF
$70 IF (LCS.GT.0) THEN
  DO $80 J=1,NF
  IF ($IXA(J).GE.0) ITERD=3
$80 CONTINUE
  ENDIF
*
*     AGGREGATION
*
  FU=ZERO
  PU=ZERO
  DO $90 KA=1,NF-N
  L=$IAA(KA)
  IF (L.GT.MCL) THEN
  L=L-MCL
  FU=FU-AZ(KA)*$AF(MA+L)
  PU=PU-AZ(KA)*$AF(MA+MA+L)
  ENDIF
$90 CONTINUE
  CALL UXVCOP(NF,$GO,$AG)
*
*     PREPARATION FOR UYTRXD - TEST VALUES DETERMINATION
*
  FUB=FP
$99 CONTINUE
  NPOM=N
  N=NF
  CALL UOD1D2(NF,$GO,$S)
  $ADD(INIT)
    NDXX='UDDBQ3'
  $ENDADD
  $EXIT
