$INTERFACE UDGLA4                                             97/12/01
$REM LU
  $CON1='1.0$P-3'
  $HELP
    STRATEGY FOR PRECISION DETERMINATION:
      1 - SINGLE STRATEGY
      2 - GEOMETRIC DECREASING STRATEGY
      3 - HARMONIC  DECREASING STRATEGY
  $CHECK(MOS,3,'1\2\3',3)
  $IF(JARA='D')
    $ADD(REAL,'\$AG($NF*$NA)\$GN($NF)\$SN($NF)\$XO($NF)\$GO($NF)&
    \$AF($NA)\$AFO($NA)')
    $POM1='V'
    $POM2=')'
  $ELSEIF(JARA='S')
    $ADD(REAL,'\$AG($MA)\$GN($NF)\$SN($NF)\$XO($NF)\$GO($NF)&
    \$AF($NA)\$AFO($NA)')
    $ADD(INTEGER,'\$IAG($NA+1)\$JAG($MA)\$IX($NX)')
    $ADD(REAL,'\UXUDOT\UXUNOR')
    $POM1='U'
    $POM2=',$$IX,KBF)'
  $ELSEIF(JARA='L')
    $U='U'
    $UM='UM'
    $HELP
      LIMITED STORAGE UPDATE:
        1 - BROYDEN UPDATE
        2 - COLUMN  UPDATE
    $CHECK(MET,1,'1\2',3)
    $HELP
      NUMBER OF BFGS CORRECTIONS
    $CHECK(MF,5,INT,2)
    $ADD(REAL,'\$AG($MA)\$XM($NF*$MF)\$GM($NA*$MF)\$XR($MF*($MF+1)/2)&
    \$UM($MF)\$U($NF)\$GN($NF)\$SN($NF)\$XO($NF)\$GO($NF)&
    \$AF($NA)\$AFO($NA)\$AFD($NF)\$AFD($NA)')
    $ADD(INTEGER,'\$IAG($NA+1)\$JAG($MA)\$JB($MF)\$IX($NX)')
    $ADD(REAL,'\UXUDOT\UXUNOR')
    $POM1='U'
    $POM2=',$$IX,KBF)'
  $ENDIF
  $ADD(REAL,'\UXVDOT\UXVNOR')
  $ADD(REAL,'\ALF\BET\GAM\RHO\RHO1\RHO2\CK\CL')
  $HELP
    MINIMUM PRECISION OF AN INEXACT SOLUTION
  $CHECK(EPS6,'0.25$P 0',REAL,4)
  CALL UOD1D1
  IF (IDECA.NE.0) THEN
  ITERD=-1
  CALL UOERR1('UD$(JARA)LA4',1)
  TDXX='BAD DEC0'
  GO TO $70
  ENDIF
  $IF(JARA='D')
    $N='N'
    IF (LD.LE.ZERO) CALL UXDCMM($N,NA,$AG,$AF,$GN)
  $ELSEIF(JARA='S')
    $N='NF'
    IF (LD.LE.ZERO) CALL UXSCMM($N,NA,MA,$AG,$IAG,$JAG,$AF,$GN)
  $ELSEIF(JARA='L')
    $N='NF'
    MX=MIN(NIT-KIT,MF)
    IF (LD.LE.ZERO) THEN
    CALL UXLCMM($N,MX,NA,MA,$AG,$IAG,$JAG,$XM,$GM,$JB,$XR,$UM,$AF,$GN&
,MET)
    ENDIF
  $ENDIF
  GNORM=SQRT(UX$(POM1)DOT($N,$GN,$GN$POM2)
  SNORM=ZERO
  PAR=MIN(EPS6,SQRT(GNORM))
  IF (PAR.GT.TEN*$CON1) THEN
  $IF(MOS=1)
  $ELSEIF(MOS=2)
    PAR=MIN(PAR,$CON1**($DBLE(NIT-LIT)/$DBLE(NF)))
  $ELSEIF(MOS=3)
    PAR=MIN(PAR,ONE/$DBLE(NIT-LIT))
  $ENDIF
  ENDIF
  PAR=PAR*PAR
  CALL UXVSET($N,ZERO,$SN)
  CALL UXVNEG(NA,$AF,$AFO)
  BET=UXVNOR(NA,$AFO)
  RHO1=MAX(ZERO,BET)
  IF(BET.GT.ZERO) THEN
  CALL UXVSCL(NA,ONE/BET,$AFO,$AFO)
  CALL UXVNEG($N,$GN,$GO)
  ALF=GNORM/BET
  RHO1=RHO1*MAX(ZERO,ALF)
  IF (ALF.GT.ZERO) THEN
  CALL UXVSCL($N,ONE/GNORM,$GO,$GO)
  CALL UXVCOP($N,$GO,$XO)
  ENDIF
  ENDIF
  TDXX='ZERO DIR'
  IF (RHO1.LE.ZERO) GO TO $20
  RHO=ALF
  GAM=BET
  DO $10 NRED=1,$N+3
*
*     BIDIAGONALIZATION
*
  $IF(JARA='D')
    CALL UXDRMD($N,NA,$AG,$GO,-ALF,$AFO,$AFO)
  $ELSEIF(JARA='S')
    CALL UXSRMD($N,NA,MA,$AG,$IAG,$JAG,$GO,-ALF,$AFO,$AFO)
  $ELSEIF(JARA='L')
    CALL UXLRMM($N,MX,NA,MA,$AG,$IAG,$JAG,$XM,$GM,$JB,$XR,$UM,$U,$GO&
,$AFD,MET)
    CALL UX$(POM1)DIR($N,-ALF,$AFO,$AFD,$AFO$POM2
  $ENDIF
  BET=UXVNOR(NA,$AFO)
  RHO2=MAX(ZERO,BET)
  IF(BET.GT.ZERO) THEN
  CALL UXVSCL(NA,ONE/BET,$AFO,$AFO)
  $IF(JARA='D')
    CALL UXDCMD($N,NA,$AG,$AFO,-BET,$GO,$GO)
  $ELSEIF(JARA='S')
    CALL UXSCMD($N,NA,MA,$AG,$IAG,$JAG,$AFO,-BET,$GO,$GO)
  $ELSEIF(JARA='L')
    CALL UXLCMM($N,MX,NA,MA,$AG,$IAG,$JAG,$XM,$GM,$JB,$XR,$UM,$AFO&
,$AFD,MET)
    CALL UX$(POM1)DIR($N,-BET,$GO,$AFD,$GO$POM2
  $ENDIF
  ALF=UX$(POM1)NOR($N,$GO$POM2
  RHO2=RHO2*MAX(ZERO,ALF)
  IF (ALF.GT.ZERO) THEN
  CALL UXVSCL($N,ONE/ALF,$GO,$GO)
  ENDIF
  ENDIF
*
*     PLANE ROTATION
*
  IF (BET.LE.ZERO) THEN
  BET=GAM/RHO
  ELSE
  CALL UXVORT(RHO,BET,CK,CL,INF)
  BET=CK*(GAM/RHO)
  ENDIF
*
*     LSQR STEP
*
  TDXX='LSQR  ST'
  CALL UX$(POM1)DIR(NF,BET,$XO,$SN,$SN$POM2
  SNORM=SQRT(UX$(POM1)DOT($N,$SN,$SN$POM2)
  RHO2=RHO2*ABS(BET)
  CALL UOD1D4(RHO1,RHO2,PAR,SNORM,XDEL)
  IF (RHO2.LE.PAR*RHO1) GO TO $20
  GAM=-CL*GAM
  BET=-CL*ALF/RHO
  RHO= CK*ALF
  CALL UX$(POM1)DIR($N,BET,$XO,$GO,$XO$POM2
$10 CONTINUE
  TDXX='MAX ITER'
*
*     AN INEXACT SOLUTION IS OBTAINED
*
$20 CONTINUE
  ITERD=2
$70 CONTINUE
  CALL UOD1D2($N,$GN,$SN)
  $ADD(INIT)
    NDXX='UD$(JARA)LA4'
  $ENDADD
  $EXIT
